<!--
 Copyright (C) 2024 bAvenir

 This program and the accompanying materials are made
 available under the terms of the Eclipse Public License 2.0
 which is available at https://www.eclipse.org/legal/epl-2.0/

 SPDX-License-Identifier: EPL-2.0
-->

<div class="w-full h-full flex gap-4">
  <form [formGroup]="createItemForm" class="grow h-full flex flex-col pt-6" (ngSubmit)="createItem()">
    <p-button
      label="Back"
      icon="pi pi-chevron-left"
      [link]="true"
      severity="secondary"
      size="small"
      (click)="onBackClick($event)"
      [style]="{ 'padding-left': '0px' }"
    ></p-button>
    <div class="w-full grow overflow-y-auto mb-4 mt-2">
      <div class="w-full h-full flex flex-col gap-6 pt-3">
        <div class="flex flex-col gap-0.5">
          <div class="text-text-300 text-sm">Name</div>
          <input
            formControlName="name"
            pInputText
            type="text"
            [placeholder]="template.title"
            [style]="{ width: '260px' }"
          />
        </div>
        <div *ngIf="template.links" class="flex flex-col gap-0.5">
          <div class="text-text-300 text-sm">Link</div>
          <input
            formControlName="link"
            pInputText
            type="text"
            placeholder="https://my-item.com"
            [style]="{ width: '260px' }"
          />
        </div>
        <div class="flex flex-col gap-0.5 w-[350px]">
          <div class="text-text-300 text-sm">Description</div>
          <textarea
            formControlName="description"
            rows="5"
            cols="40"
            pInputTextarea
            placeholder="Describe your item..."
          ></textarea>
        </div>

        <div *ngIf="authors" class="w-full flex items-center gap-6 mt-6">
          <div class="flex flex-col gap-6 min-w-[480px]">
            <div class="flex flex-col gap-0.5">
              <div class="text-text-300 text-sm">Authors</div>
              <span class="p-input-icon-left">
                <i class="fa fa-user"></i>
                <input
                  formControlName="authors"
                  pInputText
                  type="text"
                  placeholder="John Doe; Alice Smith"
                  [style]="{ width: '260px' }"
                />
              </span>
            </div>
          </div>
          <div class="w-0.5 h-full pt-[20px]">
            <div class="w-full h-full bg-borderGrey"></div>
          </div>
          <div class="pt-5 w-56">
            <p-button
              [link]="true"
              severity="danger"
              label="Remove Author"
              icon="fa fa-trash-can"
              size="small"
              (onClick)="removeAuthors()"
            ></p-button>
          </div>
        </div>

        <div *ngIf="version" class="w-full flex items-center gap-6 mt-6">
          <div class="flex flex-col gap-6 min-w-[480px]">
            <div class="flex flex-col gap-0.5">
              <div class="text-text-300 text-sm">Version</div>
              <span class="p-input-icon-left">
                <i class="fa fa-code-branch"></i>
                <input
                  formControlName="version"
                  pInputText
                  type="text"
                  placeholder="Version 1.0.0"
                  [style]="{ width: '260px' }"
                />
              </span>
            </div>
          </div>
          <div class="w-0.5 h-full pt-[20px]">
            <div class="w-full h-full bg-borderGrey"></div>
          </div>
          <div class="pt-5 w-56">
            <p-button
              [link]="true"
              severity="danger"
              label="Remove Version"
              icon="fa fa-trash-can"
              size="small"
              (onClick)="removeVersion()"
            ></p-button>
          </div>
        </div>

        <div *ngIf="location" class="w-full flex items-center gap-6 mt-6">
          <div class="flex flex-col gap-0.5 min-w-[480px]">
            <div class="text-text-300 text-sm">Location</div>
            <span class="p-input-icon-left">
              <i class="pi pi-map-marker mt-4"></i>
              <p-autoComplete
                formControlName="location"
                [suggestions]="(suggestions$ | async) ?? []"
                placeholder="Bratislava, Slovakia"
                [style]="{ width: '260px' }"
                (completeMethod)="search($event)"
                [field]="$any(selectedFeatureConversionMethod)"
                [forceSelection]="true"
                [delay]="500"
              >
                <ng-template let-address pTemplate="item">
                  <div class="flex items-center gap-2">
                    <i class="pi pi-map-marker text-text-300"></i>
                    <div class="text-left">{{ selectedFeatureConversionMethod(address) }}</div>
                  </div>
                </ng-template>
              </p-autoComplete>
            </span>
          </div>
          <div class="w-0.5 h-full pt-[20px]">
            <div class="w-full h-full bg-borderGrey"></div>
          </div>
          <div class="pt-5 w-56">
            <p-button
              [link]="true"
              severity="danger"
              label="Remove Location"
              icon="fa fa-trash-can"
              size="small"
              (onClick)="removeLocation()"
            ></p-button>
          </div>
        </div>

        <div *ngIf="license" class="w-full flex items-center gap-6 mt-6">
          <div class="flex flex-col gap-6 min-w-[480px]">
            <div class="flex flex-col gap-0.5">
              <div class="text-text-300 text-sm">License</div>
              <span class="p-input-icon-left">
                <i class="fa-solid fa-file-contract"></i>
                <input
                  formControlName="license"
                  pInputText
                  type="text"
                  placeholder="URI or literal value that identifies the license"
                  [style]="{ width: '400px' }"
                />
              </span>
            </div>
            <div class="flex flex-col gap-0.5">
              <div class="text-text-300 text-sm">License Holder</div>
              <span class="p-input-icon-left">
                <i class="fa-solid fa-file-contract"></i>
                <input
                  formControlName="licenseHolder"
                  pInputText
                  type="text"
                  placeholder="URI or literal value that identifies the license holder"
                  [style]="{ width: '400px' }"
                />
              </span>
            </div>
          </div>
          <div class="w-0.5 h-full pt-[20px]">
            <div class="w-full h-full bg-borderGrey"></div>
          </div>
          <div class="pt-5 w-56">
            <p-button
              [link]="true"
              severity="danger"
              label="Remove License"
              icon="fa fa-trash-can"
              size="small"
              (onClick)="removeLicense()"
            ></p-button>
          </div>
        </div>

        <div
          *ngIf="!location || !license || !authors || !version"
          class="text-white flex flex-wrap items-center gap-4 pb-12 mt-12"
        >
          <app-action-button
            *ngIf="!authors"
            title="Add Author"
            icon="fa fa-user"
            size="small"
            (onClick)="addAuthors()"
          >
            <ng-template #description> Add authors information to your item </ng-template>
          </app-action-button>

          <app-action-button
            *ngIf="!version"
            title="Add Version"
            icon="fa fa-code-branch"
            size="small"
            (onClick)="addVersion()"
          >
            <ng-template #description> Add version information to your item </ng-template>
          </app-action-button>

          <app-action-button
            *ngIf="!location"
            title="Add Location"
            icon="pi pi-map-marker"
            size="small"
            (onClick)="addLocation()"
          >
            <ng-template #description> Add location information to your item </ng-template>
          </app-action-button>

          <app-action-button
            *ngIf="!license"
            title="Add License"
            icon="fa-solid fa-file-contract"
            size="small"
            (onClick)="addLicense()"
          >
            <ng-template #description> Add license information to your item </ng-template>
          </app-action-button>
        </div>
      </div>
    </div>
    <div>
      <p-button
        label="Create Item"
        [disabled]="(createItemForm.statusChanges | async) != 'VALID'"
        (onClick)="createItem()"
        [loading]="loading$ | async"
      ></p-button>
    </div>
  </form>
  <div class="h-full pt-2">
    <div class="min-w-[460px] card h-full flex flex-col overflow-y-auto">
      <div class="text-sm text-text-300 pt-4">Selected template</div>
      <div class="pt-6 pb-4 flex items-center gap-4">
        <app-type-icon [size]="44"></app-type-icon>
        <div class="grow">
          <div class="text-text-500 text-xl font-semibold">{{ template.title }}</div>
          <div class="flex items-center text-sm text-text-300 gap-2">
            <i [class]="type.icon" style="font-size: 0.8"></i>
            <div>{{ type.title.length <= 0 ? 'Unknown type' : type.title }}</div>
          </div>
        </div>
      </div>
      <div class="mt-3 text-text-300 text-sm">{{ propNum }}</div>
      <div class="grow pb-10">
        <div *ngFor="let prop of properties" class="[&:not(:last-child)]:border-b border-borderGrey pb-8 mt-6">
          <div class="pb-4">
            <div class="text-md font-semibold text-secondary-900">{{ prop.key }}</div>
          </div>
          <app-prop-info [item]="template" [prop]="prop" [hideOverflownDescription]="false"></app-prop-info>
        </div>
      </div>
    </div>
  </div>
</div>
